#define debug if(0)
#include <bits/stdc++.h>
using namespace std;
#define REP(i,n) for(int i=0;i<int(n);++i)
#define REPD(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define FOR(i,a,b) for (int i=(a); i<(b); ++i)
#define FORD(i,a,b) for (int i=((int)(a))-1; i>=(b); --i)
#define FWD(i,a,b) for (int i=(a); i<(b); ++i)
#define BCK(i,a,b) for (int i=(a); i>(b); --i)
#define SIZE(c) ((int)((c).size()))
#define ALL(v) (v).begin(), (v).end()
#define VAR(v) #v << " " << v << " "
#define pb push_back
#define mp make_pair
#define st first
#define nd second
template<typename T>
ostream& dbg_print(ostream& out, const T& dbg_t){
    out << "[";
    for (auto i : dbg_t) out << i << ", ";
    out << "]";
    return out;
}
template<typename T> ostream& operator<<(ostream& out, const set<T>& dbg_t) {
    return dbg_print(out, dbg_t);
}
template<typename T> ostream& operator<<(ostream& out, const vector<T>& dbg_t) {
    return dbg_print(out, dbg_t);
}
template<typename S, typename T> ostream& operator<<(ostream& out, const pair<S, T>& rhs) {
    out << "(" << rhs.st << "," << rhs.nd << ")";
    return out;
}
template<typename T> void max_e(T& aaa, const T& bbb) { aaa = max(aaa, bbb); }
template<typename T> void min_e(T& aaa, const T& bbb) { aaa = min(aaa, bbb); }
typedef long long LL;
typedef pair<int, int> PII;
typedef vector<int> VI;

struct xy {
    int x, y;
    xy() {}
    xy(int x_, int y_): x(x_), y(y_) {}
};
ostream& operator<<(ostream& out, xy p) { 
    out << "(" << p.x << "," << p.y << ")";
    return out;
}
xy operator+(const xy& a, const xy& b) { return xy(a.x + b.x, a.y + b.y); }
xy operator-(const xy& a, const xy& b) { return xy(a.x - b.x, a.y - b.y); }
bool operator<(const xy& a, const xy& b) { return mp(a.x, a.y) < mp(b.x, b.y); }
LL det(const xy& a, const xy& b) { return LL(a.x) * b.y - LL(a.y) * b.x; }
bool vec_clockwise(const xy& a, const xy& b) { return det(a, b) < 0; }

vector<xy> polygon, inside;
vector<VI> around;

struct AngleCmp { 
    xy root;
    AngleCmp(const xy& root_): root(root_) {}
    bool operator()(const xy& a, const xy& b) { return vec_clockwise(a - root, b - root); } 
};

void scan_vector(vector<xy>& v) {
    int n;
    cin >> n;
    v.resize(n);
    REP (i, n) cin >> v[i].x >> v[i].y;
}

int id(xy p) { 
    int r = (int)(lower_bound(ALL(inside), p) - inside.begin()); 
    assert(r < SIZE(inside));
    return r;
}

int extract(VI& t) { 
    int r = t.back();
    t.pop_back();
    return r;
}

LL mergesort(VI& t, int b, int e) {
    if (e - b <= 1) return 0;
    int s = (b + e) / 2;
    LL result = mergesort(t, b, s) + mergesort(t, s, e);
    vector<int> left, right;
    FORD (i, s, b) left.pb(t[i]);
    FORD (i, e, s) right.pb(t[i]);
    FOR (i, b, e) {
        if (left.empty()) t[i] = extract(right);
        else if (right.empty()) t[i] = extract(left);
        else if (left.back() < right.back()) t[i] = extract(left);
        else if (left.back() > right.back()) {
            t[i] = extract(right);
            result += SIZE(left);
        } else assert(false);
    }
    return result;
}

LL inversions(VI t) { return mergesort(t, 0, SIZE(t)); }

LL below(int a, int b) {
    debug cout << "below " << VAR(a) << VAR(b) << endl;
    vector<xy> around_a, around_b;
    for (auto i : inside) {
        if (vec_clockwise(polygon[b] - polygon[a], i - polygon[a])) around_a.pb(i);
        if (vec_clockwise(i - polygon[b], polygon[a] - polygon[b])) around_b.pb(i);
    }
    sort(ALL(around_a), AngleCmp(polygon[a]));
    sort(ALL(around_b), AngleCmp(polygon[b]));
    debug cout << VAR(around_a) << endl;
    debug cout << VAR(around_b) << endl;
    vector<int> tmp(SIZE(inside), -1);
    REP (i, SIZE(around_a)) tmp[id(around_a[i])] = i;
    vector<int> tmp2;
    REP (i, SIZE(around_b)) tmp2.pb(tmp[id(around_b[i])]);
    assert(SIZE(around_a) == SIZE(around_b));
    LL result = LL(SIZE(around_a)) * (SIZE(around_a) - 1) / 2 - inversions(tmp2);
    debug cout << "below " << VAR(a) << VAR(b) << VAR(result) << endl;
    return result;
}

LL solve(int a, int b) {
    assert(a < b); assert(b < SIZE(polygon));
    LL tt, bt, tb, bb;
    tt = (a + 1 == b) ? (LL(SIZE(inside)) * (SIZE(inside) - 1) / 2) : below(a + 1, b);
    bt = below(a, b);
    tb = below(a + 1, (b + 1) % SIZE(polygon));
    bb = (a == 0 && b == SIZE(polygon) - 1) ? 0 : below(a, (b + 1) % SIZE(polygon));
    return tt - bt - tb + bb;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int z; cin >> z;
    while (z--) {
        scan_vector(polygon);
        scan_vector(inside);
        sort(ALL(inside));
        int q;
        cin >> q;
        vector<LL> solution;
        while (q--) {
            int a, b;
            cin >> a >> b;
            solution.pb(solve(a, b));
        }
        REP (i, SIZE(solution)) {
            cout << solution[i];
            if (i < SIZE(solution) - 1) cout << " ";
        }
        cout << endl;
    }
    return 0;
}
