#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct P {
	ll x, y;
	int id;
	P operator -(const P& he) const {
		return P{x - he.x, y - he.y, id};
	}
	ll operator *(const P& he) const {
		return x * he.y - y * he.x;
	}
	void read() {
		scanf("%lld%lld", &x, &y);
	}
	bool operator <(const P& he) const {
		return *this * he < 0;
	}
};
void test_case() {
	int cnt_polygon;
	scanf("%d", &cnt_polygon);
	vector<P> polygon(cnt_polygon);
	for(P& p : polygon) {
		p.read();
	}
	int cnt_inside;
	scanf("%d", &cnt_inside);
	vector<P> inside(cnt_inside);
	for(int i = 0; i < cnt_inside; ++i) {
		inside[i].read();
		inside[i].id = i;
	}
	
	vector<vector<int>> order(cnt_polygon);
	for(int who = 0; who < cnt_polygon; ++who) {
		vector<P> they;
		for(P p : inside) {
			they.push_back(p - polygon[who]);
		}
		sort(they.begin(), they.end());
		for(P p : they) {
			order[who].push_back(p.id);
		}
		assert((int) order[who].size() == cnt_inside);
	}
	// count_inv[a][b] counts pairs that intersect with a-b
	vector<vector<long long>> count_inversions(cnt_polygon, vector<long long>(cnt_polygon));
	for(int a = 0; a < cnt_polygon; ++a) {
		for(int b = a + 1; b < cnt_polygon; ++b) {
			vector<int> where(cnt_inside);
			for(int i = 0; i < cnt_inside; ++i) {
				where[order[b][i]] = i;
			}
			int B = 1;
			while(B < cnt_inside) {
				B *= 2;
			}
			vector<int> tree(2 * B);
			for(int x : order[a]) {
				int i = where[x];
				for(int j = B + i; j >= 2; j /= 2) {
					tree[j]++;
					if(j % 2 == 0) {
						count_inversions[a][b] += tree[j+1];
					}
				}
			}
			count_inversions[b][a] = count_inversions[a][b];
		}
	}
	int q;
	scanf("%d", &q);
	while(q--) {
		int a, b;
		scanf("%d%d", &a, &b);
		int a2 = (a + 1) % cnt_polygon;
		int b2 = (b + 1) % cnt_polygon;
		// a, a2, b, b2
		long long answer = count_inversions[a2][b2] + count_inversions[a][b]
			- count_inversions[a][b2] - count_inversions[a2][b];
		assert(answer % 2 == 0);
		answer /= 2;
		printf("%lld ", answer);
	}
	puts("");
}
int main() {
	int T;
	scanf("%d", &T);
	while(T--) {
		// if(T % 1000 == 0) cerr << T << endl;
		test_case();
	}
}
